> For the complete documentation index, see [llms.txt](https://docs.yarnspinner.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yarnspinner.dev/3.1/api/csharp/yarn.unity/yarn.unity.dialoguepresenterbase/yarn.unity.dialoguepresenterbase.runlineasync.md).

# RunLineAsync(LocalizedLine,LineCancellationToken)

Method in [DialoguePresenterBase](/3.1/api/csharp/yarn.unity/yarn.unity.dialoguepresenterbase.md)

## Summary

Called by the [DialogueRunner](/3.1/api/csharp/yarn.unity/yarn.unity.dialoguerunner.md) to signal that a line should be displayed to the user.

```csharp
public abstract YarnTask RunLineAsync(LocalizedLine line, LineCancellationToken token);
```

## Remarks

When this method is called, the Dialogue Presenter should present the line to the user. The content to present is contained within the `line` parameter, which contains information about the line in the user's current locale.

{% hint style="info" %}
It's up to the Dialogue Presenter to decide what "presenting" the line may mean; for example, showing on-screen text, playing voice-over audio, or updating on-screen portraits to show a picture of the speaking character.
{% endhint %}

The [DialogueRunner](/3.1/api/csharp/yarn.unity/yarn.unity.dialoguerunner.md) will wait until the tasks from all of its dialogue presenters have completed before continuing to the next piece of content. If your dialogue presenter does not need to handle the line, it should return immediately.

{% hint style="info" %}
The value of the `line` parameter is produced by the Dialogue Runner's [LineProviderBehaviour](/3.1/api/csharp/yarn.unity/yarn.unity.lineproviderbehaviour.md).
{% endhint %}

{% hint style="info" %}
The default implementation of this method takes no action and returns immediately.
{% endhint %}

## Parameters

| Name                                                                                                     | Description                                                                                                                                                                                                              |
| -------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| [Yarn.Unity.LocalizedLine](/3.1/api/csharp/yarn.unity/yarn.unity.localizedline.md) line                  | The line to present.                                                                                                                                                                                                     |
| [Yarn.Unity.LineCancellationToken](/3.1/api/csharp/yarn.unity/yarn.unity.linecancellationtoken.md) token | A [LineCancellationToken](/3.1/api/csharp/yarn.unity/yarn.unity.linecancellationtoken.md) that represents whether the dialogue presenter should hurry it its presentation of the line, or stop showing the current line. |

## Returns

A task that completes when the dialogue presenter has finished showing the line to the user.

## See Also

* [DialoguePresenterBase.RunOptionsAsync(DialogueOption\[\],CancellationToken)](/3.1/api/csharp/yarn.unity/yarn.unity.dialoguepresenterbase/yarn.unity.dialoguepresenterbase.runoptionsasync-1.md): Called by the [DialogueRunner](/3.1/api/csharp/yarn.unity/yarn.unity.dialoguerunner.md) to signal that a set of options should be displayed to the user.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.yarnspinner.dev/3.1/api/csharp/yarn.unity/yarn.unity.dialoguepresenterbase/yarn.unity.dialoguepresenterbase.runlineasync.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
